

####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was HeffteConfig.cmake                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib64/mpich/lib/Heffte/" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

if (TARGET Heffte::Heffte OR Heffte_FIND_QUIETLY)
    # respect the Heffte_FIND_QUIETLY and don't show outputs on second search
    set(Heffte_be_silent ON)
endif()

include("${CMAKE_CURRENT_LIST_DIR}/HeffteTargets.cmake")

if ("ON")
    # find dependencies
    if ("TRUE")
        find_package(OpenMP REQUIRED)
    endif()
    if (NOT "/usr/lib64/libfftw3_threads.so;/usr/lib64/libfftw3f_threads.so" STREQUAL "")
        set(THREADS_PREFER_PTHREAD_FLAG TRUE)
        find_package(Threads REQUIRED)
    endif()

    # add the target, if missing
    if (NOT TARGET Heffte::FFTW)
        add_library(Heffte::FFTW INTERFACE IMPORTED GLOBAL)
        target_link_libraries(Heffte::FFTW INTERFACE /usr/lib64/libfftw3_omp.so;/usr/lib64/libfftw3f_omp.so;/usr/lib64/libfftw3.so;/usr/lib64/libfftw3f.so;OpenMP::OpenMP_CXX)
        set_target_properties(Heffte::FFTW PROPERTIES INTERFACE_INCLUDE_DIRECTORIES /usr/include)
    endif()
endif()

if (OFF AND NOT TARGET Heffte::MKL)
    add_library(Heffte::MKL INTERFACE IMPORTED GLOBAL)
    target_link_libraries(Heffte::MKL INTERFACE )
    set_target_properties(Heffte::MKL PROPERTIES INTERFACE_INCLUDE_DIRECTORIES )
endif()

if (OFF AND NOT TARGET roc::rocfft)
    if (EXISTS /opt/rocm)
        list (APPEND CMAKE_PREFIX_PATH /opt/rocm/hip /opt/rocm)
    endif()
    find_package(rocfft REQUIRED)
endif()

if (OFF AND NOT TARGET Heffte::OneMKL)
    add_library(Heffte::OneMKL INTERFACE IMPORTED GLOBAL)
    target_link_libraries(Heffte::OneMKL INTERFACE )
endif()

if (OFF)
    if (NOT TARGET CUDA::cufft)
        cmake_policy(PUSH)
        cmake_policy(SET CMP0074 NEW)
        if (NOT CUDAToolkit_ROOT)
            set(CUDAToolkit_ROOT "")
        endif()
        find_package(CUDAToolkit REQUIRED)
        cmake_policy(POP)
    endif()
endif()

if (OFF AND NOT TARGET Heffte::MAGMA)
    add_library(Heffte::MAGMA INTERFACE IMPORTED GLOBAL)
    target_link_libraries(Heffte::MAGMA INTERFACE )
    set_target_properties(Heffte::MAGMA PROPERTIES INTERFACE_INCLUDE_DIRECTORIES )
    if (OFF)
        target_link_libraries(Heffte::MAGMA INTERFACE CUDA::cublas)
    endif()
    if (OFF)
        find_package(rocblas REQUIRED)
        find_package(rocsparse REQUIRED)
        find_package(hipblas REQUIRED)
        find_package(hipsparse REQUIRED)
        target_link_libraries(Heffte::MAGMA INTERFACE roc::rocblas roc::rocsparse roc::hipblas roc::hipsparse)
    endif()
endif()

if (ON)
    get_property(heffte_project_languages GLOBAL PROPERTY ENABLED_LANGUAGES)
    if (NOT Fortran IN_LIST heffte_project_languages)
        if (NOT CMAKE_Fortran_COMPILER)
            set(CMAKE_Fortran_COMPILER /usr/bin/gfortran)
        endif()
        enable_language(Fortran)
    endif()
    unset(heffte_project_languages)
    set(Heffte_Fortran_FOUND  "ON")
    if (NOT TARGET Heffte::Fortran)
        add_library(Heffte::Fortran INTERFACE IMPORTED GLOBAL)
        foreach(heffte_backend fftw cufft rocfft)
            if (TARGET Heffte::heffte_${heffte_backend})
                target_link_libraries(Heffte::Fortran INTERFACE Heffte::heffte_${heffte_backend})
            endif()
        endforeach()
        unset(heffte_backend)
    endif()
endif()

if (NOT TARGET MPI::MPI_CXX)
    if (NOT MPI_CXX_COMPILER)
        set(MPI_CXX_COMPILER /usr/lib64/mpich/bin/mpicxx)
    endif()
    find_package(MPI REQUIRED)
endif()

if (OFF)
    set(Heffte_PYTHON_FOUND  "ON")
    set(Heffte_PYTHONPATH "/usr/share/heffte/python")
endif()

if ("ON")
    set(Heffte_SHARED_FOUND "ON")
else()
    set(Heffte_STATIC_FOUND "ON")
endif()
set(Heffte_FFTW_FOUND    "ON")
set(Heffte_MKL_FOUND     "OFF")
set(Heffte_CUDA_FOUND    "OFF")
set(Heffte_ROCM_FOUND    "OFF")
set(Heffte_ONEAPI_FOUND  "OFF")
set(Heffte_INTRINSICS_FOUND  "")
if ("OFF")
    set(Heffte_GPUAWARE_FOUND "ON")
else()
    set(Heffte_GPUAWARE_FOUND "OFF")
endif()

check_required_components(Heffte)

if (NOT Heffte_be_silent AND (Heffte_FOUND OR "${Heffte_FOUND}" STREQUAL ""))
    # oddly enough, Heffte_FOUND is empty when there is no error
    message(STATUS "Found Heffte: /usr (found version 2.4.1)")
    set(Heffte_ALL_MODULES "")
    foreach(_heffte_mod SHARED STATIC FFTW MKL CUDA ROCM ONEAPI INTRINSICS GPUAWARE PYTHON Fortran)
        if (Heffte_${_heffte_mod}_FOUND)
            set(Heffte_ALL_MODULES "${Heffte_ALL_MODULES} ${_heffte_mod}")
        endif()
    endforeach()
    unset(_heffte_mod)
    message(STATUS "Found Heffte modules: ${Heffte_ALL_MODULES}")
endif()
